{% extends 'component/list_component.html.twig' %}

{% block tableHeader %}
    <th class="mdc-data-table__header-cell pe-0 ps-2" role="columnheader" scope="col"></th>
    <th class="mdc-data-table__header-cell pe-0 ps-0" role="columnheader" scope="col"></th>
    <th class="mdc-data-table__header-cell pe-0 ps-0" role="columnheader" scope="col"></th>
    <th class="mdc-data-table__header-cell pe-0 ps-0" role="columnheader" scope="col"></th>

    {% include 'component/list_component/columnheader_component.html.twig' with {
        'sortable': sortable,
        'label': 'Externe Konzept-ID',
        'columnId': 'externe_konzept_id',
        'ariaLabelId': 'external-concept-id',
        'ariaLabelName': 'External Concept ID'
    } only %}

    {% if is_granted('ROLE_RESTRICTED_VIEWER') == false %}
        {% include 'component/list_component/columnheader_component.html.twig' with {
            'sortable': sortable,
            'label': 'Eingestellt von',
            'columnId': 'eingestellt_von',
            'ariaLabelId': 'issued-by',
            'ariaLabelName': 'Issued By'
        } only %}
    {% endif %}

    {% include 'component/list_component/columnheader_component.html.twig' with {
        'sortable': sortable,
        'label': 'Nutzung',
        'columnId': 'nutzung',
        'ariaLabelId': 'usage',
        'ariaLabelName': 'Usage'
    } only %}

    {% include 'component/list_component/columnheader_component.html.twig' with {
        'sortable': sortable,
        'label': 'Flächenbedarf',
        'columnId': 'flaechenbedarf',
        'ariaLabelId': 'space-requirement',
        'ariaLabelName': 'Space Requirement'
    } only %}

    {% include 'component/list_component/columnheader_component.html.twig' with {
        'sortable': sortable,
        'label': 'Matching am',
        'columnId': 'matching_am',
        'ariaLabelId': 'matching-at',
        'ariaLabelName': 'Matching At'
    } only %}

    {% include 'component/list_component/columnheader_component.html.twig' with {
        'sortable': sortable,
        'label': 'Status',
        'columnId': 'status',
        'ariaLabelId': 'status',
        'ariaLabelName': 'Status'
    } only %}
{% endblock %}

{% block tableContent %}
    {% set exposeForwarding = listItem.fetchExposeForwarding() %}
    {% set matchingResponse = listItem.fetchMatchingResponse() %}

    <td class="mdc-data-table__cell pe-0 ps-2">
        {% if exposeForwarding == null %}
            {% if is_granted('ROLE_USER') == true %}
                <a href="{{ path('company_location_management_matching_object_expose_forwarding_for_settlement_concept', {'matchingResultId': listItem.getId()}) }}" class="material-icons mdc-icon-button mdc-card__action mdc-card__action--icon text-secondary mdc-tooltip-anchor" aria-describedby="settlement-concept-matching-{{ listItem.getId() }}-send-mdc-tooltip">
                    <div class="mdc-icon-button__ripple"></div>
                    send
                </a>
                <div id="settlement-concept-matching-{{ listItem.getId() }}-send-mdc-tooltip" class="mdc-tooltip" role="tooltip" aria-hidden="true">
                    <div class="mdc-tooltip__surface mdc-tooltip__surface-animation">Objekt-Kurzexposé an Konzeptanbietenden weiterleiten</div>
                </div>
            {% endif %}
        {% else %}
            <span class="material-icons mdc-card__action--icon text-disabled mdc-tooltip-anchor" aria-describedby="settlement-concept-matching-{{ listItem.getId() }}-send-mdc-tooltip">
                send
            </span>
            <div id="settlement-concept-matching-{{ listItem.getId() }}-send-mdc-tooltip" class="mdc-tooltip tooltip-longtext" role="tooltip" aria-hidden="true">
                <div class="mdc-tooltip__surface mdc-tooltip__surface-animation" >Das Objekt-Kurzexposé wurde bereits an den Konzeptanbietenden weitergeleitet</div>
            </div>
        {% endif %}
    </td>
    <td class="mdc-data-table__cell pe-0 ps-0">
        {% set contextMenuListItems = [] %}

        {% if is_granted('ROLE_USER') == true %}
            {% if exposeForwarding == null and matchingResponse == null %}
                {% set contextMenuListItems = contextMenuListItems|merge([
                    {
                        'label': 'als »irrelevant« markieren',
                        'url': path('company_location_management_matching_settlement_concept_matching_response', {'matchingResultId': listItem.getId(), 'response': constant('App\\Domain\\Entity\\Matching\\Response::DISMISS').value}),
                        'icon': 'do_not_disturb_alt'
                    },
                ]) %}
            {% endif %}

            {% if exposeForwarding != null %}
                {% set listItemPutBack = {
                    'label': 'Auf »zurückgestellt« setzen',
                    'url': path('company_location_management_matching_settlement_concept_expose_forwarding_set_forwarding_response', {'matchingResultId': listItem.getId(), 'forwardingResponse': constant('App\\Domain\\Entity\\ForwardingResponse::PUT_BACK').value}),
                    'icon': 'watch_later'
                } %}

                {% set listItemReject = {
                    'label': 'Auf »abgelehnt« setzen',
                    'url': path('company_location_management_matching_settlement_concept_expose_forwarding_reject', {'matchingResultId': listItem.getId()}),
                    'icon': 'thumb_down'
                } %}

                {% set listItemEstablishContact = {
                    'label': 'Auf »Kontakt aufgenommen« setzen',
                    'url': path('company_location_management_matching_settlement_concept_expose_forwarding_set_forwarding_response', {'matchingResultId': listItem.getId(), 'forwardingResponse': constant('App\\Domain\\Entity\\ForwardingResponse::CONTACT_ESTABLISHED').value}),
                    'icon': 'group'
                } %}

                {% set listItemContractConcluded = {
                    'label': 'Auf »Vertrag geschlossen« setzen',
                    'url': path('company_location_management_matching_settlement_concept_expose_forwarding_set_forwarding_response', {'matchingResultId': listItem.getId(), 'forwardingResponse': constant('App\\Domain\\Entity\\ForwardingResponse::CONTRACT_CONCLUDED').value}),
                    'icon': 'receipt_long'
                } %}

                {% if exposeForwarding.getForwardingResponse() == null %}
                    {% set contextMenuListItems = contextMenuListItems|merge([listItemPutBack, listItemReject, listItemEstablishContact, listItemContractConcluded]) %}
                {% elseif exposeForwarding.getForwardingResponse().name == 'PUT_BACK' %}
                    {% set contextMenuListItems = contextMenuListItems|merge([listItemReject, listItemEstablishContact, listItemContractConcluded]) %}
                {% elseif exposeForwarding.getForwardingResponse().name == 'REJECTED' %}
                    {% set contextMenuListItems = contextMenuListItems|merge([listItemPutBack, listItemEstablishContact, listItemContractConcluded]) %}
                {% elseif exposeForwarding.getForwardingResponse().name == 'CONTACT_ESTABLISHED' %}
                    {% set contextMenuListItems = contextMenuListItems|merge([listItemPutBack, listItemReject, listItemContractConcluded]) %}
                {% elseif exposeForwarding.getForwardingResponse().name == 'CONTRACT_CONCLUDED' %}
                    {% set contextMenuListItems = contextMenuListItems|merge([listItemPutBack, listItemReject, listItemEstablishContact]) %}
                {% endif %}
            {% endif %}
        {% endif %}

        {% if (contextMenuListItems is not empty) %}
            {% include 'component/mdc_context_menu_component.html.twig' with {
                'id': 'settlement_concept_matching_result_' ~ listItem.getId(),
                'listItems': contextMenuListItems
            } only %}
        {% endif %}
    </td>
    <td class="mdc-data-table__cell pe-0 ps-0">
        <a href="{{ path('company_location_management_matching_settlement_concept_matching_result', {'matchingResultId': listItem.getId()}) }}" class="material-icons mdc-icon-button mdc-card__action mdc-card__action--icon text-secondary mdc-tooltip-anchor" aria-describedby="settlement-concept-matching-{{ listItem.getId() }}-detail-mdc-tooltip">
            <div class="mdc-icon-button__ripple" href="#"></div>
            visibility
        </a>
        <div id="settlement-concept-matching-{{ listItem.getId() }}-detail-mdc-tooltip" class="mdc-tooltip" role="tooltip" aria-hidden="true">
            <div class="mdc-tooltip__surface mdc-tooltip__surface-animation">Details zum Konzept einsehen.</div>
        </div>
    </td>
    <td class="mdc-data-table__cell pe-0 ps-0">
        <button class="material-icons mdc-icon-button mdc-card__action mdc-card__action--icon text-secondary mdc-tooltip-anchor" data-coreui-toggle="modal" data-coreui-target="#settlement-concept-matching-result-{{ listItem.getId() }}" aria-describedby="settlement-concept-matching-{{ listItem.getId() }}-evaluation-mdc-tooltip">
            <div class="mdc-icon-button__ripple"></div>
            info_outline
        </button>
        <div id="settlement-concept-matching-{{ listItem.getId() }}-evaluation-mdc-tooltip" class="mdc-tooltip" role="tooltip" aria-hidden="true">
            <div class="mdc-tooltip__surface mdc-tooltip__surface-animation">Details zur Bewertung einsehen.</div>
        </div>
    </td>
    <td class="mdc-data-table__cell{% if matchingResponse != null %} text-light{% endif %}">{{ listItem.getSettlementConcept.getExternalReferenceNumber() }}</td>
    {% if is_granted('ROLE_RESTRICTED_VIEWER') == false %}
        <td class="mdc-data-table__cell{% if matchingResponse != null %} text-light{% endif %}">{{ listItem.getSettlementConcept.getSettlementConceptAccountUser().getFullName() }}</td>
    {% endif %}
    <td class="mdc-data-table__cell{% if matchingResponse != null %} text-light{% endif %}">
        {% if listItem.getSettlementConcept.getIndustryClassification().getName()|length > 30 %}
            <span class="mdc-tooltip-anchor" aria-describedby="settlement-concept-matching-{{ listItem.getId() }}-industryClassification-mdc-tooltip">
                {{ listItem.getSettlementConcept.getIndustryClassification().getName()|slice(0,27) }}...
            </span>
            <div id="settlement-concept-matching-{{ listItem.getId() }}-industryClassification-mdc-tooltip" class="mdc-tooltip tooltip-longtext" role="tooltip" aria-hidden="true">
                <div class="mdc-tooltip__surface mdc-tooltip__surface-animation">{{ listItem.getSettlementConcept.getIndustryClassification().getName() }}</div>
            </div>
        {% else %}
            {{ listItem.getSettlementConcept.getIndustryClassification().getName() }}
        {% endif %}
    </td>
    <td class="mdc-data-table__cell{% if matchingResponse != null %} text-light{% endif %}">
        {% if listItem.getSettlementConcept().SettlementConceptPropertyRequirement().getSpace().getMinimumValue() is not null %}
            {{ listItem.getSettlementConcept().SettlementConceptPropertyRequirement().getSpace().getMinimumValue()|number_format(0, ',', '.') }} m&sup2;
        {% endif %}
        bis
        {{ listItem.getSettlementConcept().SettlementConceptPropertyRequirement().getSpace().getMaximumValue()|number_format(0, ',', '.') }} m&sup2;
    </td>
    <td class="mdc-data-table__cell{% if matchingResponse != null %} text-light{% endif %}">{{ listItem.getCreatedAt().format('d.m.Y') }}<br>{{ listItem.getCreatedAt().format('H:i') }} Uhr</td>
    <td class="mdc-data-table__cell text-info">
        {% if matchingResponse != null %}
            <span class="text-danger">als irrelevant markiert</span>
        {% elseif exposeForwarding == null %}
            <span class="text-info">neu gefunden</span>
        {% else %}
            <span class=" text-info">weitergeleitet am {{ exposeForwarding.getCreatedAt().format('d.m.Y, H:i') }} Uhr</span><br>
            {% if exposeForwarding.getForwardingResponse() != null %}
                {% if exposeForwarding.getForwardingResponse().name == 'REJECTED' %}
                    <span class="text-danger">
                        {{ exposeForwarding.getForwardingResponse().getName() }}
                        {% if exposeForwarding.getUpdatedAt() != null %}am {{ exposeForwarding.getUpdatedAt().format('d.m.Y, H:i') }}{% endif %}
                    </span>
                    {% if exposeForwarding.getRejectReason() != null and exposeForwarding.getRejectReason() != '' %}
                        <i class="mdc-icon ms-0 pt-1 mdc-tooltip-anchor text-danger align-middle" aria-describedby="settlement-concept-matching-{{ listItem.getId() }}-rejectReason-mdc-tooltip">
                            <i class="material-icons" style="font-size:16px;">help_outline</i>
                        </i>
                        <div id="settlement-concept-matching-{{ listItem.getId() }}-rejectReason-mdc-tooltip" class="mdc-tooltip tooltip-longtext" role="tooltip" aria-hidden="true">
                            <div class="mdc-tooltip__surface mdc-tooltip__surface-animation">{{ exposeForwarding.getRejectReason() }}</div>
                        </div>
                    {% endif %}
                {% elseif exposeForwarding.getForwardingResponse().name == 'PUT_BACK' %}
                    <span class="text-warning">
                        {{ exposeForwarding.getForwardingResponse().getName() }}
                        {% if exposeForwarding.getUpdatedAt() != null %}am {{ exposeForwarding.getUpdatedAt().format('d.m.Y, H:i') }}{% endif %}
                    </span>
                {% else %}
                    <span class="text-success">
                        {{ exposeForwarding.getForwardingResponse().getName() }}
                        {% if exposeForwarding.getUpdatedAt() != null %}am {{ exposeForwarding.getUpdatedAt().format('d.m.Y, H:i') }}{% endif %}
                    </span>
                {% endif %}
            {% endif %}
        {% endif %}
    </td>
{% endblock %}
